Subject: Re: (about BFD echo)

From: Lokesh Bevinamarad <[email-masked]>
Date: Mon, 9 Feb 2015 15:04:02 +0530

Hello Marc,
Thanks for the reply,

If we use one knob, I think we will run into an issue that I describe below.

Lets say we use one knob to control both Echo-loopback-Advertisement and
honouring of it and I want to run echo in only one direction.
So when the knob is turned on, my device will advertise echo and honour
advertisement from peer as well.

When I turn it on in one device, nothing happens because other system may
not have the knob turned on and may not honour the advertisement.
When I turn it on in other device, both will start sending echo packets to
each other But I wanted to run echo in only one direction.

So with single knob controlling both, there seems to be no way to run echo
in one direction.

How do current implementations which use single knob solve this issue?

One way to solve this problem is always honour echo advertisement whether
or not echo is turned on or off.

Regards
-Lokesh

On Thu, Jan 29, 2015 at 3:13 PM, Marc Binderberger <[email-masked]> wrote:

> Hello Lokesh,
>
> > I understand that we can use one knob to turn on/off the Echo
> advertisement
> > (non zero value in echo-rx).
>
> that's not what I said :-) I said "turn on/off echo".
>
> Some implementations have a single knob that controls both the
> advertisement
> as well as the honoring.
>
> If you like to implement two knobs, one for advertisement and one for
> honoring - you are free to do so.
>
> > Now my question is, does RFC mean that we need another knob to control
> the
> > options stated above?
> > I think RFC is not clear on this aspect.
>
> To say the least :-) because it deliberately is not saying anything.
>
> Again, section 6.8.9 says:
>
>     The transmission of BFD Echo packets is otherwise outside the scope
>     of this specification.
>
>
> Regards, Marc
>
>
>
>
> >
> > Regards
> > -Lokesh
> >
> >
> >
> >
> > On Sat, Jan 24, 2015 at 2:46 PM, Marc Binderberger <[email-masked]>
> wrote:
> >> Hello Lokesh,
> >>
> >> you may have received unicast replies, haven't seen anything on the list
> >> though.
> >>
> >>
> >>> echo-rx value in the control packet. But it is up to the other peer if
> it
> >>> wants to honour this advertisement by sending echo packets. Right?
> >>
> >> Indeed, from RFC 5880, section 3.2:
> >>
> >>    The Echo function may be enabled individually in each direction.  It
> >>    is enabled in a particular direction only when the system that loops
> >>    the Echo packets back signals that it will allow it, and when the
> >>    system that sends the Echo packets decides it wishes to.
> >>
> >> And section 6.8.9:
> >>
> >>    The transmission of BFD Echo packets is otherwise outside the scope
> >>    of this specification.
> >>
> >>
> >>> Does RFC mean that whether peer honours the advertisement or not should
> >> be
> >>> configured by admin?
> >>
> >> The RFC does not exclude this option and I guess that is what most
> >> implementations do - they have a config knob to turn on/off echo. If you
> >> come
> >> up with a different mechanism you are free to implement it.
> >>
> >> I assume you understand that "honors the advertisement or not" is only
> an
> >> option when the peer sends control packets with the "Required Min Echo
> RX
> >> Interval" field being non-zero. In case the field is zero ...
> >>
> >>       If the Required Min Echo RX Interval field is zero, the
> >>       transmission of Echo packets, if any, MUST cease.
> >>
> >> ... you must stop sending echo; there is no option to honor or not.
> >>
> >>
> >> Best regards,
> >> Marc
> >>
> >>
> >>
> >>
> >> On Wed, 21 Jan 2015 17:26:40 +0530, Lokesh Bevinamarad wrote:
> >>> Hello All,
> >>> As per RFC 5880, if echo function is on, it means that device is
> willing
> >> to
> >>> loopback the peers echo packets and advertises this by setting non zero
> >>> echo-rx value in the control packet. But it is up to the other peer if
> it
> >>> wants to honour this advertisement by sending echo packets. Right?
> >>>
> >>> I have a doubt here.
> >>> Does RFC mean that whether peer honours the advertisement or not should
> >> be
> >>> configured by admin?
> >>>
> >>>
> >>>
> >>> Regards
> >>> -Lokesh
> >
>